//////////////////////////////////////////////////////////////
//	J2O v0.1.3
//	Programmer: Debugger 2.0
//	Copyright: (c) Debugger 2.0 2008
//  License: GNU GPL v3	(see http://www.gnu.org/licenses/)
//////////////////////////////////////////////////////////////

var j2o = {
	jXHR : null,
	engine : {
		xhr: !!(window.XMLHttpRequest),
		events: !!(window.addEventListener)
	},
	addEvent : function(element, type, expression){
		if(j2o.engine.events) {
			element.addEventListener(type, expression, false);
		}else{
			element.attachEvent('on' + type, expression);
		}
	},
	setStyle : function(id, text){
		var element = document.getElementById(id);
		(j2o.engine.events)?(element.setAttribute("style", text)):(element.style.cssText = text);
	},
	createXMLHttpRequest : function(){
		if(j2o.engine.xhr){
			jXHR = new XMLHttpRequest();	
		}
		else{
			jXHR = new ActiveXObject("Microsoft.XMLHTTP");
		}
	},
	makeRequest : function(url, handler, mode, params, async){
		j2o.createXMLHttpRequest();
		if(async==undefined){
			async=true;
		}
		if(mode==undefined){
			mode='GET';
		}
		if((mode.toLowerCase() == 'get')&&(params!=undefined)){
			url = url + '?' + params;
			params = null;
		}
		jXHR.onreadystatechange = handler;
		jXHR.open(mode, url, async);
		if(mode.toLowerCase() == 'post'){
			jXHR.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			jXHR.setRequestHeader("Content-length", params.length);
			jXHR.setRequestHeader("Connection", "close");
		}
		jXHR.send(params);
	},
	rankbar : function(){
		this.starfront = 'images/star.png';
		this.starback = 'images/blackstar.png';
		this.maxstars = 5;
		this.finished = new Array();
		this.browser;
		function getAttributeByName(tag, attribute){
			if(browser){
				return tag.attributes[attribute].nodeValue;
			}
			else{
				return tag.getAttribute(attribute);	
			}
		}
		function getBars() {
			var allTags = document.getElementsByTagName("span");
			var bars = new Array();
			var allTagsLen = allTags.length;
			var classe;
			var j = 0;
			for (i = 0; i < allTagsLen; i++) {
				classe = getAttributeByName(allTags[i], "class");
				if((classe!=null) && (classe.match(/rankbar/))) {
					bars[j] = allTags[i];
					j++;
				}
			}
			this.length = bars.length;
			return bars;
		}
		this.init = function(){
			(j2o.engine.events)?(browser = false):(browser = true);
			var rank = new getBars();
			var i = 0;
			while(i<rank.length){
				rankbar.createRB(rank[i].id);
				i++;
			}
		};
		this.getRank = function(id){
			var i = 0;
			var x = 0;
			while(i<rankbar.maxstars){
				var star = document.getElementById(id + '_rnk_' + i);
				if((star.parentNode.id == id) && (star.src.match(rankbar.starfront))){
					x++;		
				}
				i++;
			}
			return x;
		};
		this.createRB = function(id){
			var element = document.getElementById(id);
			var star;
			var value = getAttributeByName(element, "class").replace('rankbar_', '');
			var i = 0;
			while(i<rankbar.maxstars){
				stars = document.createElement('img');
				if(i<eval(value)){
					stars.src = rankbar.starfront;
				}else{
					stars.src = rankbar.starback;
				}
				stars.id = id + '_rnk_' + i;
				j2o.addEvent(
						stars, 
						"mouseover", 
						rankbar.makebcolor
				);
				j2o.addEvent(
						stars,
						"click",
						rankbar.makeend
				);
				if(document.all){
					document.all[id].appendChild(stars);	
				}else{
					element.appendChild(stars);
				}
				i++;
			}
		};
		this.makebcolor = function(e){
				var y = 0;
				while(y<rankbar.finished.length){
					if(rankbar.finished[y] == e.target.parentNode.id){
						return;		
					}	
					y++;
				}
				if(e.target.src.match(rankbar.starback)){
					var i = eval(e.target.id.replace(e.target.parentNode.id + '_rnk_', ''));
					var element = document.getElementById(e.target.parentNode.id + '_rnk_' + i);
					while(i >= 0){
						element = document.getElementById(e.target.parentNode.id + '_rnk_' + i);
						element.setAttribute('src', rankbar.starfront);
						i--;
					}
				}else{
					var i = eval(e.target.id.replace(e.target.parentNode.id + '_rnk_', '')) + 1;
					var element = document.getElementById(e.target.parentNode.id + '_rnk_' + i);
					while(i < rankbar.maxstars){
						element = document.getElementById(e.target.parentNode.id + '_rnk_' + i);
						element.setAttribute('src', rankbar.starback);
						i++;
					}
				}
		};
		this.makeend = function(e){
			var i = 0;
			while(i<rankbar.finished.length){
				if(rankbar.finished[i] == e.target.parentNode.id){
					alert('Gi votato');		
				}	
				i++;
			}
			rankbar.finished[rankbar.finished.length+1] = e.target.parentNode.id;
		}
	},
	progressbar : function(){
		this.show_value = true;
		this.max_length = 200;
		this.height = 14;
		this.imgfront = 'images/progressbar_apple.png';
		this.imgback = 'images/blackbar_apple.png';
		this.browser;
		function getBars() {
			var allTags = document.getElementsByTagName("span");
			var bars = new Array();
			var allTagsLen = allTags.length;
			var j = 0;
			for (i = 0; i < allTagsLen; i++) {
				if(getAttributeByName(allTags[i], "class") == 'progressbar') {
					bars[j] = allTags[i];
					j++;
				}
			}
			this.length = bars.length;
			return bars;
		}
		this.init = function(){
			(j2o.engine.events)?(browser = false):(browser = true);
			var static = new getBars();
			var i = 0;
			while(i<static.length){
				progressbar.createPB(static[i].id, 'static');
				i++;
			}
		};
		function getAttributeByName(tag, attribute){
			if(browser){
				return tag.attributes[attribute].nodeValue;
			}
			else{
				return tag.getAttribute(attribute);	
			}
		}
		function percentFloat(value){
			value = value.replace("%", "");
			value = parseFloat(value);
			value = value.toFixed(2);
			return value;
		}	
		function percentInt(value){
			value = value.replace("%", "");
			value = parseInt(value);
			return value;
		}	
		function applySettings(element, percentuale){
			if(progressbar.show_value == false){
				element.innerHTML = "&nbsp;";
			}
		}	
		function createAttributes(tag, type, width, title, id){
			if(type == "front"){
				tag.src = progressbar.imgfront;
			}else{
				tag.src = progressbar.imgback;
			}
			tag.width = width;
			tag.title = title;
			tag.height = progressbar.height;
			tag.alt = title;
			tag.id = id;
		}	
		function setAttributes(tag, width, title){
			tag.setAttribute("width", width);
			tag.setAttribute("alt", title);
			tag.setAttribute("title", title);
		}		
		function trim(s){
			return s.replace(/^\s+|\s+$/g, "");
		}		
		function isFloat(s){
			var n = trim(s);
			return n.length>0 && !(/[^0-9.]/).test(n) && (/\.\d/).test(n);
		}		
		this.createPB = function(id, type){
			var element = document.getElementById(id);
			var percentuale = percentFloat(element.innerHTML);
			var ex = eval(percentFloat(element.innerHTML));
			applySettings(element);
			var img = document.createElement("img");
			var img_back = document.createElement("img");
			var width =  percentuale * progressbar.max_length / 100;
			createAttributes(img, "front", width, percentuale + "%", id + "_front");
			createAttributes(img_back, "back", progressbar.max_length - width, percentuale + "%", id + "_back");
			if(document.all){
				document.all[id].appendChild(img);	
				document.all[id].appendChild(img_back);
			}else{
				element.appendChild(img);
				element.appendChild(img_back);
			}
		};
		function isInt(x) {
   			var y=parseInt(x);
   			if (isNaN(y)) 
				return false;
  			return x==y && x.toString()==y.toString();
 		} 	
		this.add = function(id, toadd){
			var element = document.getElementById(id);
			var img = document.getElementById(id + "_front");
			var img_back = document.getElementById(id + "_back");
			var percentuale = percentFloat(img.getAttribute("title"));
			var ex_percent = eval(percentuale) + "%";
			percentuale = eval(percentuale) + eval(toadd);
			var width =  percentuale * progressbar.max_length / 100;
			if(width <= progressbar.max_length && width >= 0){
				setAttributes(img, width, percentuale + "%");
				setAttributes(img_back, progressbar.max_length - width, percentuale + "%");
				percentuale = (isInt(eval(percentuale)))?(eval(percentuale)):(eval(percentuale.toFixed(2)));
				element.innerHTML = element.innerHTML.replace(ex_percent, percentuale + "%");
			}
		};
		this.subtract = function(id, tosub){
			tosub = -tosub;
			progressbar.add(id, tosub);
		}
	}
};

var progressbar = new j2o.progressbar();
j2o.addEvent(window, "load", progressbar.init);
var rankbar = new j2o.rankbar();
j2o.addEvent(window, "load", rankbar.init);