//////////////////////////////////////////////////////////////
//	J2O v0.1.2
//	Programmer: Debugger 2.0
//	Copyright: (c) Debugger 2.0 2008
//	Note: Sorry for my bad english if there're errors
//////////////////////////////////////////////////////////////

/*
*  License: GNU GPL v3	
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/*	J2O Class
 *	Description: Initialization of the J2O Class. This Class will cointain all subclasses of the library
 *	Subclasses: rankbar, progressbar
 *	Functions: addEvent, createXMLHttpRequest, makeRequest
 */
var j2o = {
	jXHR : null, //internal object that will cointain the XMLHttpRequest Object
	engine : {
		xhr: !!(window.XMLHttpRequest), //check if the browser engine support the XMLHttpRequest
		events: !!(window.addEventListener)	//check if the browser support the addEventListener method
	},
	//cross-browser function that allow to add event listenere with any browser
	addEvent : function(element, type, expression){
		if(j2o.engine.events) {
			element.addEventListener(type, expression, false);
		}else{
			element.attachEvent('on' + type, expression);
		}
	},
	setStyle : function(id, text){
		var element = document.getElementById(id);
		(j2o.engine.events)?(element.setAttribute("style", text)):(element.style.cssText = text);
	},
	//cross-browser creation of the XMLHttpRequest;
	createXMLHttpRequest : function(){
		if(j2o.engine.xhr){
			jXHR = new XMLHttpRequest();	
		}
		else{
			jXHR = new ActiveXObject("Microsoft.XMLHTTP");
		}
	},
	/*	Function: makeRequest
	 *	Description: semplified Ajax request function
	 *	Parameters: url (url to request), handler (function that will handle the request), mode (POST or GET), params (parameters), async
	 */
	makeRequest : function(url, handler, mode, params, async){
		j2o.createXMLHttpRequest();//creation of the XHR object
		//checking if the params are defined
		if(async==undefined){
			async=true;
		}
		if(mode==undefined){
			mode='GET';
		}
		//if params isn't null and the mode is 'get', append the parameters to the url to request
		if((mode.toLowerCase() == 'get')&&(params!=undefined)){
			url = url + '?' + params;
			params = null;
		}
		jXHR.onreadystatechange = handler;
		jXHR.open(mode, url, async);
		//POST request mode fix
		if(mode.toLowerCase() == 'post'){
			jXHR.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			jXHR.setRequestHeader("Content-length", params.length);
			jXHR.setRequestHeader("Connection", "close");
		}
		//sending parameters
		jXHR.send(params);
	},
	/*	Class: rankbar
	 *	Description: this create the rankbar class. It's used to create rankbar components
	 */
	rankbar : function(){
		this.starfront = 'images/star.png';//colored star
		this.starback = 'images/blackstar.png';//uncolored star
		this.maxstars = 5;//max stars in a rankbar
		this.finished = new Array();//array wich will contain the IDs of rankbars already votated
		this.browser;
		
		//function that get an attribute of a tag by his name
		function getAttributeByName(tag, attribute){
			if(browser){
				return tag.attributes[attribute].nodeValue;
			}
			else{
				return tag.getAttribute(attribute);	
			}
		}
		
		//get all rankbars
		function getBars() {
			var allTags = document.getElementsByTagName("span");
			var bars = new Array();//array wich contains all elements with 'rankbar' class
			var allTagsLen = allTags.length;
			var classe;
			for (i = 0, j = 0; i < allTagsLen; i++) {
				classe = getAttributeByName(allTags[i], "class");
				if((classe!=null) && (classe.match(/rankbar/))) {
					bars[j] = allTags[i];
					j++;
				}
			}
			this.length = bars.length;//how many rankbars are in the page
			return bars;//return the array
		}
		
		/*	Function: init (abbr of Initialization)
		 *	Description: this function initialize all the rankbars in the web page. This happen when the page is loaded, so that all bars are already formed when the user interact with the page
		 */
		this.init = function(){
			(j2o.engine.events)?(browser = false):(browser = true);//check what browser is in use
			var rank = new getBars();
			var i = 0;
			while(i<rank.length){
				createRB(rank[i].id);//for all bars found, it create the rankbar
				i++;
			}
		}
		
		/*	Function: getRank
		 *	Description: return the value of the rankbar by id
		 */
		this.getRank = function(id){
			var i = 0;
			var x = 0;
			while(i<rankbar.maxstars){
				var star = document.getElementById(id + '_rnk_' + i);
				if((star.parentNode.id == id) && (star.src.match(rankbar.starfront))){
					x++;		
				}
				i++;
			}
			return x;
		}
		
		/*	Function: createRB
		 *	Description: create the rankbar. It insert the stars needed to create it
		 *	Parameters: id (of the span element)
		 */		
		function createRB(id){
			var element = document.getElementById(id);
			var star;
			var value = getAttributeByName(element, "class").replace('rankbar_', '');
			var i = 0;
			while(i<rankbar.maxstars){
				stars = document.createElement('img');
				if(i<eval(value)){
					stars.src = rankbar.starfront;
				}else{
					stars.src = rankbar.starback;
				}
				stars.id = id + '_rnk_' + i;
				j2o.addEvent(
						stars, 
						"mouseover", 
						rankbar.makebcolor
				);
				j2o.addEvent(
						stars,
						"click",
						rankbar.makeend
				);
				if(document.all){
					document.all[id].appendChild(stars);	
				}else{
					element.appendChild(stars);
				}
				i++;
			}
		}
		
		/*	Function: makebcolor
		 *	Description: this function attend to manage colored stars and uncolored stars of alla rankbars.
		 */
		this.makebcolor = function(e){
				//First of all, check if the bar that is getting the mouseover event is already clicked. If is it, exit the function
				var y = 0;
				while(y<rankbar.finished.length){
					if(rankbar.finished[y] == e.target.parentNode.id){
						return;		
					}	
					y++;
				}
				//if the star image that is getting the mouseover event is a uncolored star, makebcolor make it colored, else makebcolor make it uncolored
				if(e.target.src.match(rankbar.starback)){
					var i = eval(e.target.id.replace(e.target.parentNode.id + '_rnk_', ''));
					var element = document.getElementById(e.target.parentNode.id + '_rnk_' + i);
					while(i >= 0){
						element = document.getElementById(e.target.parentNode.id + '_rnk_' + i);
						element.setAttribute('src', rankbar.starfront);
						i--;
					}
				}else{
					var i = eval(e.target.id.replace(e.target.parentNode.id + '_rnk_', '')) + 1;
					var element = document.getElementById(e.target.parentNode.id + '_rnk_' + i);
					while(i < rankbar.maxstars){
						element = document.getElementById(e.target.parentNode.id + '_rnk_' + i);
						element.setAttribute('src', rankbar.starback);
						i++;
					}
				}
		}
		/*	Function: makeend
		 */
		this.makeend = function(e){
			var i = 0;
			while(i<rankbar.finished.length){
				if(rankbar.finished[i] == e.target.parentNode.id){
					alert('Gi votato');		
				}	
				i++;
			}
			rankbar.finished[rankbar.finished.length+1] = e.target.parentNode.id;
		}
	},
	/*	Progressbar class
	 */
	progressbar : function(){
		this.show_value = true;
		this.max_length = 200;
		this.height = 14;
		this.imgfront = 'images/progressbar_apple.png';
		this.imgback = 'images/blackbar_apple.png';
		this.browser;
		
		function getBars() {
			var allTags = document.getElementsByTagName("span");
			var bars = new Array();
			var allTagsLen = allTags.length;
			for (i = 0, j = 0; i < allTagsLen; i++) {
				if(getAttributeByName(allTags[i], "class") == 'progressbar') {
					bars[j] = allTags[i];
					j++;
				}
			}
			this.length = bars.length;
			return bars;
		}
		
		this.init = function(){
			(j2o.engine.events)?(browser = false):(browser = true);
			var static = new getBars();
			var i = 0;
			while(i<static.length){
				createPB(static[i].id, 'static');
				i++;
			}
		}

		function getAttributeByName(tag, attribute){
			if(browser){
				return tag.attributes[attribute].nodeValue;
			}
			else{
				return tag.getAttribute(attribute);	
			}
		}
	
		function percentFloat(value){
			value = value.replace("%", "");
			value = parseFloat(value);
			value = value.toFixed(2);
			return value;
		}
		
		function percentInt(value){
			value = value.replace("%", "");
			value = parseInt(value);
			return value;
		}
	
		function applySettings(element, percentuale){
			if(progressbar.show_value == false){
				element.innerHTML = "&nbsp;";
			}
		}
	
		function createAttributes(tag, type, width, title, id){
			if(type == "front"){
				tag.src = progressbar.imgfront;
			}else{
				tag.src = progressbar.imgback;
			}
			tag.width = width;
			tag.title = title;
			tag.height = progressbar.height;
			tag.alt = title;
			tag.id = id;
		}
	
		function setAttributes(tag, width, title){
			tag.setAttribute("width", width);
			tag.setAttribute("alt", title);
			tag.setAttribute("title", title);
		}
		
		function trim(s){
			return s.replace(/^\s+|\s+$/g, "");
		}
		
		function isFloat(s){
			var n = trim(s);
			return n.length>0 && !(/[^0-9.]/).test(n) && (/\.\d/).test(n);
		}
		
		function createPB(id, type){
			var element = document.getElementById(id);
			var percentuale = percentFloat(element.innerHTML);
			var ex = eval(percentFloat(element.innerHTML));
			applySettings(element);
			var img = document.createElement("img");
			var img_back = document.createElement("img");
			var width =  percentuale * progressbar.max_length / 100;
			createAttributes(img, "front", width, percentuale + "%", id + "_front");
			createAttributes(img_back, "back", progressbar.max_length - width, percentuale + "%", id + "_back");
			if(document.all){
				document.all[id].appendChild(img);	
				document.all[id].appendChild(img_back);
			}else{
				element.appendChild(img);
				element.appendChild(img_back);
			}
		}
	
		function isInt(x) {
   			var y=parseInt(x);
   			if (isNaN(y)) 
				return false;
  			return x==y && x.toString()==y.toString();
 		} 
	
		this.add = function(id, toadd){
			var element = document.getElementById(id);
			var img = document.getElementById(id + "_front");
			var img_back = document.getElementById(id + "_back");
			var percentuale = percentFloat(img.getAttribute("title"));
			var ex_percent = eval(percentuale) + "%";
			percentuale = eval(percentuale) + eval(toadd);
			var width =  percentuale * progressbar.max_length / 100;
			if(width <= progressbar.max_length && width >= 0){
				setAttributes(img, width, percentuale + "%");
				setAttributes(img_back, progressbar.max_length - width, percentuale + "%");
				percentuale = (isInt(eval(percentuale)))?(eval(percentuale)):(eval(percentuale.toFixed(2)));
				element.innerHTML = element.innerHTML.replace(ex_percent, percentuale + "%");
			}
		}
	
		this.subtract = function(id, tosub){
			tosub = -tosub;
			progressbar.add(id, tosub);
		}
	}
};

var progressbar = new j2o.progressbar();
j2o.addEvent(window, "load", progressbar.init);
var rankbar = new j2o.rankbar();
j2o.addEvent(window, "load", rankbar.init);